#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';


$copfiltersettings{'ACTION'} = '';
$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_ftp.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}




################################################################################
##   FTP
################################################################################

######### FTP_SCAN_GREEN
$selected{'FTP_SCAN_GREEN'}{'off'} = '';
$selected{'FTP_SCAN_GREEN'}{'on'} = '';
$selected{'FTP_SCAN_GREEN'}{$copfiltersettings{'FTP_SCAN_GREEN'}} = "selected='selected'";

######### FTP_SCAN_ORANGE
$selected{'FTP_SCAN_ORANGE'}{'off'} = '';
$selected{'FTP_SCAN_ORANGE'}{'on'} = '';
$selected{'FTP_SCAN_ORANGE'}{$copfiltersettings{'FTP_SCAN_ORANGE'}} = "selected='selected'";

######### FTP_SCAN_BLUE
$selected{'FTP_SCAN_BLUE'}{'off'} = '';
$selected{'FTP_SCAN_BLUE'}{'on'} = '';
$selected{'FTP_SCAN_BLUE'}{$copfiltersettings{'FTP_SCAN_BLUE'}} = "selected='selected'";

######### FTP_VIRUS_SCAN
$selected{'FTP_VIRUS_SCAN'}{'off'} = '';
$selected{'FTP_VIRUS_SCAN'}{'on'} = '';
$selected{'FTP_VIRUS_SCAN'}{$copfiltersettings{'FTP_VIRUS_SCAN'}} = "selected='selected'";



################################################################################
##   ACTIONs
################################################################################




######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 





ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################





################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/frox_enable";


        if ( $copfiltersettings{'FTP_SCAN_GREEN'} eq 'on' || $copfiltersettings{'FTP_SCAN_BLUE'} eq 'on' || $copfiltersettings{'FTP_SCAN_ORANGE'} eq 'on' )
        {
                 $copfiltersettings{'FTP_VIRUS_SCAN'} = 'on';
        }
        else
        {
                 $copfiltersettings{'FTP_VIRUS_SCAN'} = 'off';
        }



            if ( $copfiltersettings{'FTP_SCAN_GREEN'} eq 'on' || 
                 $copfiltersettings{'FTP_SCAN_ORANGE'} eq 'on' || 
                 $copfiltersettings{'FTP_SCAN_BLUE'} eq 'on' ) {
			system ('/bin/touch', "${copfilter_swroot}/etc/frox_enable"); }

# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);

        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} frox..</b> <br />";
            system('/usr/local/bin/copfilter_restartfrox');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }

        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - FTP Scanning
################################################################################
my $output = `/etc/rc.d/init.d/copfilter_frox pid weboutput`;
my $status = "";
if ( $output =~ /OFF/ ) { $status="<td width='200' height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td width='200' height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $output =~ /ON/ ) { $status="<td width='200' height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

print "<a name='ftp'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter ftp'} (frox):");
print "<form method='post' action='/cgi-bin/copfilter_ftp.cgi' enctype='multipart/form-data'>";
print <<END

<table width='400' cellpadding='5'>
<tr>
    <td colspan='2'><font size='2.7em'><b>Frox Status:</b></td>
    $status
    <td colspan='2'>&nbsp;</td>
</tr>
<table border='0' cellpadding='5'>

<tr>
	<td width='210'></td>
	<td width='100'></td>
	<td width='50'></td>
	<td width='190'></td>
	<td>&nbsp;</td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter ftp_scan_green'}</td>
        <td> <select name='FTP_SCAN_GREEN'>
             <option value='on' $selected{'FTP_SCAN_GREEN'}{'on'}>on</option>
             <option value='off' $selected{'FTP_SCAN_GREEN'}{'off'}>off</option> </select></td>
<!--
        always scan for viruses
        <td> &nbsp;</td>
        <td> $Lang::tr{'copfilter ftp_virscan'}</td>
        <td> <select name='FTP_VIRUS_SCAN'>
             <option value='on' $selected{'FTP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'FTP_VIRUS_SCAN'}{'off'}>off</option> </select></td>
-->


</tr>
<tr>
END
;
if ($netsettings{'ORANGE_DEV'}) {
print <<END
        <td> $Lang::tr{'copfilter ftp_scan_orange'}</td>
        <td> <select name='FTP_SCAN_ORANGE'>
             <option value='on' $selected{'FTP_SCAN_ORANGE'}{'on'}>on</option>
             <option value='off' $selected{'FTP_SCAN_ORANGE'}{'off'}>off</option> </select></td>
END
;
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
}
print <<END
	<td> </td>
	<td> </td>
	<td> </td>


</tr>
<tr>
END
;
if ($netsettings{'BLUE_DEV'}) {
print <<END
        <td> $Lang::tr{'copfilter ftp_scan_blue'}</td>
        <td> <select name='FTP_SCAN_BLUE'>
             <option value='on' $selected{'FTP_SCAN_BLUE'}{'on'}>on</option>
             <option value='off' $selected{'FTP_SCAN_BLUE'}{'off'}>off</option> </select></td>
END
;
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
}
print <<END
	<td> </td>
	<td> </td>
</tr>
<tr>
	<td colspan='4'> $Lang::tr{'copfilter ftp2'} </td>
</tr>

</table>

<table width='100%' border='0' cellpadding='3'>
<tr>
        <td width='50%'>$Lang::tr{'copfilter ftp restart'} </td>
</tr>
<tr>
        <td width='50%' valign='bottom'>
            <input type='checkbox' name='SKIP_RESTART'>
             $Lang::tr{'copfilter skip restart'}
        <br>
        <input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}'> </td>
	<td width='50%' align='right' valign='bottom'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>

</tr>

</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
