#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2010/30/12 karesmakro
#

# Add entry in menu
# MENUENTRY copfilter 080 "IM Proxy" "copfilter imspector"
#
# Make sure translation exists $Lang::tr{'copfilter imspector'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';



$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_imspector.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}

sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}




################################################################################
##   IMSPECTOR
################################################################################

######### IMSPECTOR_PROXY_GREEN
$selected{'IMSPECTOR_PROXY_GREEN'}{'off'} = '';
$selected{'IMSPECTOR_PROXY_GREEN'}{'on'} = '';
$selected{'IMSPECTOR_PROXY_GREEN'}{$copfiltersettings{'IMSPECTOR_PROXY_GREEN'}} = "selected='selected'";

######### IMSPECTOR_PROXY_ORANGE
$selected{'IMSPECTOR_PROXY_ORANGE'}{'off'} = '';
$selected{'IMSPECTOR_PROXY_ORANGE'}{'on'} = '';
$selected{'IMSPECTOR_PROXY_ORANGE'}{$copfiltersettings{'IMSPECTOR_PROXY_ORANGE'}} = "selected='selected'";

######### IMSPECTOR_PROXY_BLUE
$selected{'IMSPECTOR_PROXY_BLUE'}{'off'} = '';
$selected{'IMSPECTOR_PROXY_BLUE'}{'on'} = '';
$selected{'IMSPECTOR_PROXY_BLUE'}{$copfiltersettings{'IMSPECTOR_PROXY_BLUE'}} = "selected='selected'";

######### IM_ICQ_PROTOCOL
$selected{'IM_ICQ_PROTOCOL'}{'off'} = '';
$selected{'IM_ICQ_PROTOCOL'}{'on'} = '';
$selected{'IM_ICQ_PROTOCOL'}{$copfiltersettings{'IM_ICQ_PROTOCOL'}} = "selected='selected'";

######### IM_IRC_PROTOCOL
$selected{'IM_IRC_PROTOCOL'}{'off'} = '';
$selected{'IM_IRC_PROTOCOL'}{'on'} = '';
$selected{'IM_IRC_PROTOCOL'}{$copfiltersettings{'IM_IRC_PROTOCOL'}} = "selected='selected'";

######### IM_MSN_PROTOCOL
$selected{'IM_MSN_PROTOCOL'}{'off'} = '';
$selected{'IM_MSN_PROTOCOL'}{'on'} = '';
$selected{'IM_MSN_PROTOCOL'}{$copfiltersettings{'IM_MSN_PROTOCOL'}} = "selected='selected'";

######### IM_YAHOO_PROTOCOL
$selected{'IM_YAHOO_PROTOCOL'}{'off'} = '';
$selected{'IM_YAHOO_PROTOCOL'}{'on'} = '';
$selected{'IM_YAHOO_PROTOCOL'}{$copfiltersettings{'IM_YAHOO_PROTOCOL'}} = "selected='selected'";

######### IM_GG_PROTOCOL
$selected{'IM_GG_PROTOCOL'}{'off'} = '';
$selected{'IM_GG_PROTOCOL'}{'on'} = '';
$selected{'IM_GG_PROTOCOL'}{$copfiltersettings{'IM_GG_PROTOCOL'}} = "selected='selected'";

######### IM_JABBER_PROTOCOL
$selected{'IM_JABBER_PROTOCOL'}{'off'} = '';
$selected{'IM_JABBER_PROTOCOL'}{'on'} = '';
$selected{'IM_JABBER_PROTOCOL'}{$copfiltersettings{'IM_JABBER_PROTOCOL'}} = "selected='selected'";

######### IMSPECTOR_FILES
$selected{'IM_BLOCK_FILES'}{'off'} = '';
$selected{'IM_BLOCK_FILES'}{'on'} = '';
$selected{'IM_BLOCK_FILES'}{$copfiltersettings{'IM_BLOCK_FILES'}} = "selected='selected'";

######### IMSPECTOR_WEBCAMS
$selected{'IM_BLOCK_WEBCAMS'}{'off'} = '';
$selected{'IM_BLOCK_WEBCAMS'}{'on'} = '';
$selected{'IM_BLOCK_WEBCAMS'}{$copfiltersettings{'IM_BLOCK_WEBCAMS'}} = "selected='selected'";

################################################################################
##   ACTIONs
################################################################################

######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if  ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_ICQ_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_IRC_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_MSN_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_YAHOO_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_GG_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_JABBER_PROTOCOL'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_BLOCK_FILES'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_BLOCK_WEBCAMS'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 



ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/imspector_enable";


            if ( $copfiltersettings{'IMSPECTOR_PROXY_GREEN'} eq 'on' || 
                 $copfiltersettings{'IMSPECTOR_PROXY_ORANGE'} eq 'on' || 
                 $copfiltersettings{'IMSPECTOR_PROXY_BLUE'} eq 'on' ) {
			system ('/bin/touch', "${copfilter_swroot}/etc/imspector_enable"); 
			$copfiltersettings{'IM_SCAN'} = 'on'; }


# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);

        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} imspector..</b> <br />";
            system('/usr/local/bin/copfilter_restartimspector');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }



}




################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);
if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    #print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}

################################################################################
##  Website IMSPECTOR Proxy
################################################################################
my $output = `/etc/rc.d/init.d/copfilter_imspector pid weboutput`;
my $status = "";
if ( $output =~ /OFF/ ) { $status="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $output =~ /ON/ ) { $status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

print "<a name='imspector'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter imspector'} (IMSPECTOR):");
print "<form method='post' action='/cgi-bin/copfilter_imspector.cgi' enctype='multipart/form-data'>";
print <<END
<style type="text/css">
	#x1 {
		display: none;
	}
</style>
</head>

<script language="JavaScript1.2">
var yes = false;
function flip(num) 
{ 
	if (yes)
	{
		document.getElementById('x'+num).style.display = 'none';
		yes = false;
	}
	else
	{
		document.getElementById('x'+num).style.display = 'block';
		yes = true;
	}
} 
</script> 

<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>Imspector Status:</b></td>
    $status
</tr>
<tr>
	<td nowrap colspan='3'></td>
</tr>
</table>

<table border='0' cellpadding='5'>

<tr>
	<td width='220'></td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter imspector_proxy_green'}</td>
        <td> <select name='IMSPECTOR_PROXY_GREEN'>
             <option value='on' $selected{'IMSPECTOR_PROXY_GREEN'}{'on'}>on</option>
             <option value='off' $selected{'IMSPECTOR_PROXY_GREEN'}{'off'}>off</option> </select></td>
</tr>
<tr>
END
;
if ($netsettings{'ORANGE_DEV'}) {
print "<td> $Lang::tr{'copfilter imspector_proxy_orange'}</td>\n";
print "<td> <select name='IMSPECTOR_PROXY_ORANGE'>\n";
print "      <option value='on' $selected{'IMSPECTOR_PROXY_ORANGE'}{'on'}>on</option>\n";
print "      <option value='off' $selected{'IMSPECTOR_PROXY_ORANGE'}{'off'}>off</option> </select></td>\n";
system ("/cgi-bin/copfilter_imlog.cgi");
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
}
print <<END

</tr>
<tr>
END
;
if ($netsettings{'BLUE_DEV'}) {
print <<END
        <td> $Lang::tr{'copfilter imspector_proxy_blue'}</td>
        <td> <select name='IMSPECTOR_PROXY_BLUE'>
             <option value='on' $selected{'IMSPECTOR_PROXY_BLUE'}{'on'}>on</option>
             <option value='off' $selected{'IMSPECTOR_PROXY_BLUE'}{'off'}>off</option> </select></td>
END
;
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
;
}
print <<END

</tr>
<tr>
        <td colspan='4'> $Lang::tr{'copfilter imspector_note'} </td>
</tr>
END
;

# Imspector config settings

print "<td><h3>Imspector settings:\n</h3></td>";
print "<tr><td><b>Protocol settings:\n</b></td></tr>";
print <<END
<tr>
	<td width='150'> $Lang::tr{'copfilter imspector_icq_protocol'}</td>
        <td> <select name='IM_ICQ_PROTOCOL'>
             <option value='on' $selected{'IM_ICQ_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_ICQ_PROTOCOL'}{'off'}>off</option> </select></td>
END
;
print <<END
	<td width='150'> $Lang::tr{'copfilter imspector_irc_protocol'}</td>
        <td> <select name='IM_IRC_PROTOCOL'>
             <option value='on' $selected{'IM_IRC_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_IRC_PROTOCOL'}{'off'}>off</option> </select></td>
        <tr> </tr>
	<td width='150'> $Lang::tr{'copfilter imspector_msn_protocol'}</td>
        <td> <select name='IM_MSN_PROTOCOL'>
             <option value='on' $selected{'IM_MSN_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_MSN_PROTOCOL'}{'off'}>off</option> </select></td>
	<td width='150'> $Lang::tr{'copfilter imspector_yahoo_protocol'}</td>
        <td> <select name='IM_YAHOO_PROTOCOL'>
             <option value='on' $selected{'IM_YAHOO_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_YAHOO_PROTOCOL'}{'off'}>off</option> </select></td>
        <tr> </tr>
	<td width='150'> $Lang::tr{'copfilter imspector_gg_protocol'}</td>
        <td> <select name='IM_GG_PROTOCOL'>
             <option value='on' $selected{'IM_GG_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_GG_PROTOCOL'}{'off'}>off</option> </select></td>
	<td width='150'> $Lang::tr{'copfilter imspector_jabber_protocol'}</td>
        <td> <select name='IM_JABBER_PROTOCOL'>
             <option value='on' $selected{'IM_JABBER_PROTOCOL'}{'on'}>on</option>
             <option value='off' $selected{'IM_JABBER_PROTOCOL'}{'off'}>off</option> </select></td>
        <tr> </tr>
        <tr><td><b>Blocking:\n</b></td></tr>
	<td width='150'> $Lang::tr{'copfilter imspector_block_files'}</td>
        <td> <select name='IM_BLOCK_FILES'>
             <option value='on' $selected{'IM_BLOCK_FILES'}{'on'}>on</option>
             <option value='off' $selected{'IM_BLOCK_FILES'}{'off'}>off</option> </select></td>
	<td width='150'> $Lang::tr{'copfilter imspector_block_webcams'}</td>
        <td> <select name='IM_BLOCK_WEBCAMS'>
             <option value='on' $selected{'IM_BLOCK_WEBCAMS'}{'on'}>on</option>
             <option value='off' $selected{'IM_BLOCK_WEBCAMS'}{'off'}>off</option> </select></td>
        <tr> </tr>
</tr>
</table>
END
;

# <------ here you will find the real time log viewer in future -----!>

print "<table border='0' width='100%'>";
print <<END
    <tr>
    <td width='50%'><a href="javascript: void()" onclick="flip(1)"><img src='/images/logviewer.png' width='240' height='68' alt='*' /></div></a>
        <div id="x1"><iframe src="/cgi-bin/copfilter_imlog.cgi" width="850" height="470" frameborder="0"></iframe></div><br />
    </td></tr>
END
;
print <<END
<tr>
        <td width='50%' valign='bottom'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        <br>
	<input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td width=50%' align='right' valign='bottom'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>
</tr>
</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
